-- Lout output
-- public domain FA 1996-05

indexing
	description: "Eiffel output for Basser Lout";
	licence: public_domain;
	interface: client, mixin;
	 
class EIFFEL_LOUT inherit EIFFEL_PRINT end

creation make
	
feature
	
	print_prologue is
		do
			io.put_string("lines @Break {")
			io.put_new_line
		end

	print_epilogue is
		do
			io.put_string("}")
			io.put_new_line
		end

feature	{ PUBLIC_NONE }
	
	print_character(c : CHARACTER) is
		do
			if c = '#' or c = '&' or c = '/' 
					or c = '@' or c = '^' or c = '{' 
					or c = '}' or c = '|' or c = '~' then
				io.put_character('%"')
				io.put_character(c)
				io.put_character('%"')
			elseif c = '\' or c = '%"' then
				io.put_string("%"\")
				io.put_character(c)
				io.put_character('%"')
			else
				io.put_character(c)
			end
		end

	print_new_line is
		do
			io.put_new_line
		end

feature { PUBLIC_NONE }
	
	print_keyword(str : STRING) is
		do
			io.put_string("@B{")
			io.put_string(str)
			io.put_string("}")
		end

	print_identifier, print_number(str : STRING) is
		do
			io.put_string("@I{")
			io.put_string(str)
			io.put_string("}")
		end

	print_quoted_string(str : STRING) is
		do
			io.put_string("@I{")
			print_verbatim(str)
			io.put_string("}")
		end
	
	print_comment(str : STRING) is
		do
			print_verbatim(str) -- stay roman
		end
	
end -- class EIFFEL_LOUT